﻿using System;
using System.Collections;
using System.Text;
using System.Threading;

namespace ClaireLuneV2
{
    class Program
    {
        static Int32 posx = 0, posy = 0;
        const Int32 increment = 15;

        static bool debounce()
        {
            BrainPad.Wait.Milliseconds(30);
            if (BrainPad.Buttons.IsLeftPressed())
            {
                BrainPad.Buzzer.StartBuzzing(523); //do
                return true;
            }
            else if (BrainPad.Buttons.IsUpPressed())
            {
                BrainPad.Buzzer.StartBuzzing(587);// ré
                return true;
            }
            else if (BrainPad.Buttons.IsRightPressed())
            {
                BrainPad.Buzzer.StartBuzzing(659);// mi
                return true;
            }
            else
            {
                BrainPad.Buzzer.StopBuzzing();
                return false;
            }
        }

        static void play(string note)
        {
            if (debounce())
            {
                BrainPad.Display.DrawSmallText(posx, posy, note);
                BrainPad.Display.RefreshScreen();
                posx += increment;
                if (posx > 119)
                {
                    posy += 15; posx = 0;
                }
            }
        }

        static void Main()
        {
            BrainPad.Display.DrawText(20, 5, "Au clair ");
            BrainPad.Display.DrawText(30, 25, "de la");
            BrainPad.Display.DrawText(20, 50, "lune v2");
            BrainPad.Display.RefreshScreen();
            Thread.Sleep(2000);
            BrainPad.Display.Clear();

            BrainPad.Buttons.WhenLeftButtonPressed += Buttons_WhenLeftButtonPressed;
            BrainPad.Buttons.WhenLeftButtonReleased += Buttons_WhenLeftButtonReleased;
            BrainPad.Buttons.WhenUpButtonPressed += Buttons_WhenUpButtonPressed;
            BrainPad.Buttons.WhenUpButtonReleased += Buttons_WhenUpButtonReleased;
            BrainPad.Buttons.WhenRightButtonPressed += Buttons_WhenRightButtonPressed;
            BrainPad.Buttons.WhenRightButtonReleased += Buttons_WhenRightButtonReleased;

            Thread.Sleep(-1);

        }

        private static void Buttons_WhenRightButtonReleased()
        {
            debounce();
        }

        private static void Buttons_WhenUpButtonReleased()
        {
            debounce();
        }

        private static void Buttons_WhenLeftButtonReleased()
        {
            debounce();
        }

        private static void Buttons_WhenLeftButtonPressed()
        {
            play("do");
        }

        private static void Buttons_WhenUpButtonPressed()
        {
            play("Re");
        }

        private static void Buttons_WhenRightButtonPressed()
        {
            play("mi");
        }
    }
}
